var Semver = require('semver');
var Request = require('request');
var Constant = require('../modules/Constant');
var PackageJSON = require('../../package.json');

module.exports = {
  _getReleaseInfo: function() {
    console.log(Constant.REMOTE_URL);
    var promise = new Promise(function(resolve, reject) {
      Request.get({
        url: Constant.REMOTE_URL,
        json: true
      }, function(error, response, body) {
        if (error) {
          reject(error);
        } else {
          resolve(body);
        }
      });
    });
    return promise;
  },

  checkUpdate: function() {
    return this._getReleaseInfo().then(function(result) {
      if (result) {
        var latestVersion = result.version;
        var currentVersion = PackageJSON.version;
        var isNewer = false;

        if (latestVersion) {
          isNewer = Semver.gt(latestVersion, currentVersion);
        }

        // only send the result back when we got new version
        if (isNewer) {
          return result;
        }
      }
    });
  }
};
